#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Automaton.h"
#include "CutDouble.h"



/* FONCTION QUI RENVOIE UN BOOLEEN DISANT SI LE MOT PASSE EN PARAMETRE */
/* EXISTE DEJA DANS LA LISTE DE CHAINES WordList                       */
/* CETTE FONCTION TIENT EN MEME TEMPS A JOUR LA LISTE WordList DE      */
/* FACON A CE QU'ELLE NE CONTIENNE PAS DE DOUBLONS                     */
/* LES MOTS MIS DANS WordList SON TRAITES PAR <<COPIE>> DONC IL EST    */
/* POSSIBLE DE LIBERER LA CHAINE UTILISEE POUR L'APPEL DANS L'APPELANT */
/* IL Y A DONC EFFET DE BORD, LA LISTE ETANT MODIFIEE VIA SON POINTEUR */
/* L'AJOUT SE FAIT EN TETE.                                            */

BOOL CutDouble (WordList, Word)
     struct StringItem **WordList ;
     UBYTE *Word ;

{
struct StringItem *Parse ;
struct StringItem *Tmp ;

Parse = *WordList ;
while (Parse)
  {
    if (strcmp (Word, Parse->String) == 0)
      return (TRUE) ;
    Parse = Parse->Next ;
  }

/* SI ON ARRIVE ICI, C'EST QUE LE MOT N'EXISTAIT PAS DANS LA LISTE */
/* DONC ON RAJOUTE LE MOT DANS LA LISTE */
Tmp = (struct StringItem*) malloc (sizeof (struct StringItem)) ;
if (Tmp == NULL)
  {
    printf ("Not enought memory.\n") ;
    printf ("I can't work any more...\n") ;
    exit (0) ;
  }

Tmp->Next = *WordList ;
Tmp->String = (UBYTE*) malloc (strlen(Word)+1) ;
if (Tmp->String == NULL)
  {
    printf ("Not enought memory.\n") ;
    printf ("I can't work any more...\n") ;
    exit (0) ;
  }
strcpy (Tmp->String, Word) ;
/* ON CHANGE LE POINTEUR DE TETE DE LISTE */
*WordList = Tmp ;

return (FALSE) ;
}



void ResetWordList (WordList)
     struct StringItem **WordList ;

{
struct StringItem *Parse ;
struct StringItem *Tmp ;

Parse = *WordList ;
/* ON LIBERE TOUTE LA MEMOIRE */
while (Parse)
  {
    free (Parse->String) ;
    Tmp = Parse->Next ;
    free (Parse) ;
    Parse = Tmp ;
  }

/* ON REMET LE POINTEUR A NULL */
*WordList = NULL ;
}
