#include "Automaton.h"

#ifdef PROTOS_NEEDED
#include "Prototypes.h"
#endif


extern DAGElement *Automaton ;
extern ULONG AutomatonSize ;




void MatchWord (Word, Buffer, IWord, IBuff, Base)
	UBYTE *Word ;
	UBYTE *Buffer ;
	UBYTE IWord ;
	UBYTE IBuff ;
	ULONG Base ;

{
ULONG i ;


if (Base == END_TRANSITION)
	return ;

if (IWord >= strlen(Word))
	return ;

if (Word[IWord] == '*')
  {
    /* ON EST SUR UN CARACTERE A MATCHER */
    for (i=1;i<256;i++)
      {
	/* FIRST, WE MUST TEST BOUNDARIES TO AVOID CRASHING WITH MMU */
	if (Base+i < AutomatonSize)
	  {
	    if (GETCHAR (Automaton[Base+i]) == (UBYTE) i)
	      {
		Buffer[IBuff] = (UBYTE) i ;
		if (IWord == strlen(Word)-1)
		  {
		    /* SI ON EST ARRIVE A LA FIN DU MOT A MATCHER... */
		    if (GETISFINAL (Automaton[Base+i]))
		      {
			/* SI LA SOLUTION TROUVEE EST UN MOT COMPLET... */
			Buffer[IBuff+1] = '\0' ;
			printf ("-> %s\n", Buffer) ;
		      }
		  }
		else
		  {
		    /* SINON, ON N'EST PAS ARRIVE A LA FIN DU MOT */
		    MatchWord (Word, Buffer, IWord+1, IBuff+1, GETNEXTBASE (Automaton[Base+i])) ;
		  }
	      }
	  }
      }
  }
else
  {
    /* ON EST SUR UNE LETTRE VOULUE TELLE QUELLE */
    i = Word[IWord] ;
    if (Base+i < AutomatonSize)
      {
	if (GETCHAR (Automaton[Base+i]) == (UBYTE) i)
	  {
	    Buffer[IBuff] = (UBYTE) i ;
	    if (IWord == strlen(Word)-1)
	      {
		/* SI ON EST ARRIVE A LA FIN DU MOT A MATCHER... */
		if (GETISFINAL (Automaton[Base+i]))
		  {
		    /* SI LA SOLUTION TROUVEE EST UN MOT COMPLET... */
		    Buffer[IBuff+1] = '\0' ;
		    printf ("-> %s\n", Buffer) ;
		  }
	      }
	    else
	      {
		/* SINON, ON N'EST PAS ARRIVE A LA FIN DU MOT */
		MatchWord (Word, Buffer, IWord+1, IBuff+1, GETNEXTBASE (Automaton[Base+i])) ;
	      }
	  }
      }
  }
}




