#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Automaton.h"
#ifdef PROTOS_NEEDED
#include "Exists.h"
#endif



extern DAGElement *Automaton ;
extern ULONG AutomatonSize ;



ULONG Exists (InitialState, Word)
     ULONG InitialState ;
     UBYTE *Word ;

{
  ULONG Base ;
  ULONG i ;
  UBYTE TmpChar ;
  DAGElement TmpDAGElem ;

  Base = InitialState ;

  for (i=0;i<strlen (Word);i++)
    {
      if (Base+Word[i] >= AutomatonSize) return (FALSE) ;
      TmpDAGElem = Automaton[Base+Word[i]] ;

      TmpChar = GETCHAR (TmpDAGElem) ;
      if (TmpChar == '\0') return (FALSE) ;
      if (TmpChar != Word[i]) return (FALSE) ;
      Base = GETNEXTBASE (TmpDAGElem) ;
    }

  /* ON DOIT S'ASSURER QUE L'ETAT EST BIEN FINAL (QU'IL REPRESENTE BIEN UN MOT) */
  /* C'EST POUR CA QU'ON A GARDE LE DAGElement TRAITE DANS CHAQUE BOUCLE */
  /* AINSI, ON GARDE LE DERNIER POUR NOTRE TEST */
  if (GETISFINAL (TmpDAGElem))
    return (TRUE) ;
  else
    return (FALSE) ;
}
