let rec fct = function str1 -> function str2 ->
	match str1 with
		"" ->
			begin
			match str2 with
				"" -> false   (* T = 1 = 2 *)
				| _ -> true (* F = 1 < 2 *)
			end
		|_ ->
			begin
			match str2 with
				"" -> false  (* T = 1 = 2 *)
				| _ ->
					let c1 = int_of_char (nth_char str1 0)
					and c2 = int_of_char (nth_char str2 0)
					in
		if c1=c2 then
                        fct (sub_string str1 1 ((string_length str1)-1))
                            (sub_string str2 1 ((string_length str2)-1))
			else
			if c1<c2 then true
			else false
			end
;;


let rec buildlist = function filehd ->
  try
   begin
	let foo = (input_line filehd) in
	 foo :: (buildlist filehd)
   end
  with
    End_of_file  -> []
;;

let buildlist2 = function filename ->
	buildlist (open_in filename) ;;


let rec dumplist = function outhd -> function
	[] -> close_out outhd
 	| hd :: q ->
		output_string outhd hd ;
		output_string outhd "\n" ;
		dumplist outhd q
;;

let dumplist2 = function filename -> function liste ->
	dumplist (open_out filename) liste ;;


let sortlist = function liste ->
	sort__sort fct liste ;;


let moulinette = function infile -> function outfile ->
	let l1 = buildlist2 infile in
	let l2 = sortlist l1 in
	dumplist2 outfile l2 ;;
